package org.dromara.web.service;


import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.web.domain.ProductNutrition;
import org.dromara.web.domain.bo.BatchProductNuyritionBo;
import org.dromara.web.domain.bo.ProductNutritionBo;
import org.dromara.web.domain.vo.ProductNutritionVo;
import org.springframework.web.multipart.MultipartFile;

import java.util.Collection;
import java.util.List;

/**
 * 营养产品信息Service接口
 *
 * @author h
 * @date 2025-06-26
 */
public interface IProductNutritionService {

    /**
     * 查询营养产品信息
     *
     * @param id 主键
     * @return 营养产品信息
     */
    ProductNutritionVo queryById(Long id);

    /**
     * 分页查询营养产品信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 营养产品信息分页列表
     */
    TableDataInfo<ProductNutritionVo> queryPageList(ProductNutritionBo bo, PageQuery pageQuery);

    TableDataInfo<ProductNutritionVo> listAll();

    /**
     * 查询符合条件的营养产品信息列表
     *
     * @param bo 查询条件
     * @return 营养产品信息列表
     */
    List<ProductNutritionVo> queryList(ProductNutritionBo bo);

    /**
     * 新增营养产品信息
     *
     * @param bo 营养产品信息
     * @return 是否新增成功
     */
    Boolean insertByBo(ProductNutritionBo bo);

    /**
     * 修改营养产品信息
     *
     * @param bo 营养产品信息
     * @return 是否修改成功
     */
    Boolean updateByBo(ProductNutritionBo bo);

    /*批量修改 许可证 保质期临期提醒*/
    Boolean batchUpdateNutrition(BatchProductNuyritionBo bo);

    /**
     * 校验并批量删除营养产品信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    R<?> importExcel(MultipartFile file) throws Exception;
}
